// Copyright (c) 2015, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import 'package:analyzer/src/generated/sdk_io.dart';
import 'package:analyzer/src/generated/sdk.dart';
import 'package:analyzer/src/generated/java_io.dart';
import 'package:analyzer/src/generated/engine.dart';
import 'package:analyzer/src/generated/source.dart';
import 'package:analyzer/src/generated/ast.dart';
import 'package:plugin/manager.dart';
import 'package:analyzer/src/plugin/engine_plugin.dart';
import '../generated/test_support.dart';

main() {
  ExtensionManager extensionManager = new ExtensionManager();
  EnginePlugin plugin = AnalysisEngine.instance.enginePlugin;
  if (plugin.taskExtensionPoint == null) {
    extensionManager.processPlugins([plugin]);
  }

  DartSdk sdk = new DirectoryBasedDartSdk(
      new JavaFile('/Users/scheglov/Applications/dart/dart-sdk'));
  AnalysisEngine.instance.useTaskModel = true;
  InternalAnalysisContext context =
      AnalysisEngine.instance.createAnalysisContext();
  var sourceFactory = new SourceFactory(<UriResolver>[
    new DartUriResolver(sdk) /*,
    new ResourceUriResolver(resourceProvider)*/
  ]);
//  context = createAnalysisContext();
  context.sourceFactory = sourceFactory;

  Source source = new TestSource('/test.dart');
  context.setContents(source, r'''
//const AAA = BBB + CCC;
//const BBB = 1;
//const CCC = 2;
class A {
  m() {}
}
class B extends A {
  @override
  m() {};
}
''');
  CompilationUnit unit = context.resolveCompilationUnit2(source, source);
  print(unit);
  print(unit);
  {
    var changeSet = new ChangeSet()..changedSource(source);
    context.applyChanges(changeSet);
  }
  var cache = context.analysisCache;
  print(cache);
  print(cache);
}
